/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 2

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         CATA_STYPE
/* Substitute the variable and function names.  */
#define yyparse         cata_parse
#define yylex           cata_lex
#define yyerror         cata_error
#define yydebug         cata_debug
#define yynerrs         cata_nerrs


/* Copy the first part of user declarations.  */
#line 26 "../parser/catalogFile.y" /* yacc.c:339  */

#include "../mediatex.h"
#include "../misc/log.h"
#include "../misc/locks.h"
#include "../memory/ardsm.h"
#include "../memory/catalogTree.h"

// hack because Flex needs YYSTYPE from tab.h and Bison needs yyscan_t from .h
typedef void* yyscan_t;

#line 84 "catalogFile.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "catalogFile.tab.h".  */
#ifndef YY_CATA_CATALOGFILE_TAB_H_INCLUDED
# define YY_CATA_CATALOGFILE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef CATA_DEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define CATA_DEBUG 1
#  else
#   define CATA_DEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define CATA_DEBUG 1
# endif /* ! defined YYDEBUG */
#endif  /* ! defined CATA_DEBUG */
#if CATA_DEBUG
extern int cata_debug;
#endif

/* Token type.  */
#ifndef CATA_TOKENTYPE
# define CATA_TOKENTYPE
  enum cata_tokentype
  {
    catHUMCARAC = 258,
    catCONCARAC = 259,
    catRECCARAC = 260,
    catDOCCARAC = 261,
    catTOP = 262,
    catCATEGORY = 263,
    catROLE = 264,
    catHUMAN = 265,
    catDOCUMENT = 266,
    catWITH = 267,
    catARCHIVE = 268,
    catCOLON = 269,
    catEQUAL = 270,
    catDOT = 271,
    catCOMMA = 272,
    catHASH = 273,
    catNUMBER = 274,
    catSTRING = 275
  };
#endif
/* Tokens.  */
#define catHUMCARAC 258
#define catCONCARAC 259
#define catRECCARAC 260
#define catDOCCARAC 261
#define catTOP 262
#define catCATEGORY 263
#define catROLE 264
#define catHUMAN 265
#define catDOCUMENT 266
#define catWITH 267
#define catARCHIVE 268
#define catCOLON 269
#define catEQUAL 270
#define catDOT 271
#define catCOMMA 272
#define catHASH 273
#define catNUMBER 274
#define catSTRING 275

/* Value type.  */
#if ! defined CATA_STYPE && ! defined CATA_STYPE_IS_DECLARED
typedef union CATA_STYPE CATA_STYPE;
union CATA_STYPE
{
#line 37 "../parser/catalogFile.y" /* yacc.c:355  */

  off_t  size;
  char   string[MAX_SIZE_STRING+1];
  char   hash[MAX_SIZE_HASH+1];
  Category* category;
  Human*    human;
  Document* document;
  Archive*  archive;

#line 182 "catalogFile.tab.c" /* yacc.c:355  */
};
# define CATA_STYPE_IS_TRIVIAL 1
# define CATA_STYPE_IS_DECLARED 1
#endif



int cata_parse (yyscan_t yyscanner, Collection* coll, Category* category, Human* human, Document* document, Archive* archive);
/* "%code provides" blocks.  */
#line 58 "../parser/catalogFile.y" /* yacc.c:355  */

/*=======================================================================
 * Version: this file is generated by BISON using catalogFile.y
 * Project: MediaTeX
 * Module : catalogFile parser
 *
 * catalog parser

 MediaTex is an Electronic Records Management System
 Copyright (C) 2014 2015 Nicolas Roche
   
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 any later version.
   
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
   
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 =======================================================================*/
  #include "../memory/catalogTree.h"
  int parseCatalogFile(Collection* coll, const char* path);

#line 220 "catalogFile.tab.c" /* yacc.c:355  */

#endif /* !YY_CATA_CATALOGFILE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */
#line 47 "../parser/catalogFile.y" /* yacc.c:358  */

// we need YYSTYPE defined first to include the Flex headers
#include "catalogFile.h"

#define LINENO cata_get_lineno(yyscanner)
  
void cata_error(yyscan_t yyscanner, Collection* coll, Category* category,
		Human* human, Document* document, Archive* archive,
		const char* message);

#line 236 "catalogFile.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined CATA_STYPE_IS_TRIVIAL && CATA_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  25
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   61

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  21
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  34
/* YYNRULES -- Number of rules.  */
#define YYNRULES  60
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  87

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   275

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20
};

#if CATA_DEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   129,   129,   131,   135,   140,   146,   150,   154,   158,
     166,   171,   176,   184,   189,   194,   202,   207,   212,   220,
     225,   230,   240,   246,   252,   258,   265,   272,   280,   286,
     293,   302,   308,   314,   320,   327,   335,   342,   348,   358,
     364,   372,   380,   389,   398,   406,   413,   419,   425,   431,
     439,   445,   451,   456,   460,   464,   469,   477,   482,   486,
     492
};
#endif

#if CATA_DEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "catHUMCARAC", "catCONCARAC",
  "catRECCARAC", "catDOCCARAC", "catTOP", "catCATEGORY", "catROLE",
  "catHUMAN", "catDOCUMENT", "catWITH", "catARCHIVE", "catCOLON",
  "catEQUAL", "catDOT", "catCOMMA", "catHASH", "catNUMBER", "catSTRING",
  "$accept", "file", "stanzas", "stanza", "cateCaracs", "cateCarac",
  "docCaracs", "docCarac", "humCaracs", "humCarac", "archCaracs",
  "archCarac", "defCategory", "newCategory", "categories", "category",
  "defHuman", "newHuman", "human", "humCategories", "defArchive",
  "newArchive", "archive", "defDocument", "newDocument", "document",
  "docCategories2", "docCategories", "docCaracs2", "docWiths", "roles",
  "role", "docArchives", "archives", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275
};
# endif

#define YYPACT_NINF -72

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-72)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
      -2,     7,    -4,     0,     2,     5,    24,    -2,   -72,   -72,
     -10,   -72,    -1,   -72,     6,   -72,    11,     8,   -72,     9,
     -72,   -72,   -72,    13,   -72,   -72,   -72,    12,    16,    18,
     -72,    12,    21,    19,   -72,    25,     6,   -72,    12,    29,
     -72,   -72,    23,   -72,    -3,   -72,    26,   -72,   -72,     1,
      27,   -72,    28,   -72,   -72,    32,    30,    31,    29,   -72,
     -72,    12,    18,   -72,    12,    19,   -72,   -72,    12,    37,
      38,    31,   -72,     5,   -72,   -72,   -72,   -72,     0,    34,
     -72,   -72,   -72,     5,   -72,   -72,   -72
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     0,     0,     0,     0,     0,     2,     5,     6,
      25,     7,    34,     9,    40,     8,    47,     0,    27,     0,
      35,    45,    44,     0,    41,     1,     4,     0,     0,    24,
      11,     0,     0,    33,    17,     0,    39,    20,     0,    53,
      26,    36,     0,    30,    23,    29,     0,    10,    38,    32,
       0,    16,     0,    19,    49,    46,     0,    51,    52,    55,
      42,     0,    22,    12,     0,    31,    18,    21,     0,     0,
       0,    50,    14,    58,    54,    28,    37,    48,     0,     0,
      13,    60,    43,    57,    56,    15,    59
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -72,   -72,   -72,    36,    14,   -28,   -72,   -27,    10,   -30,
     -72,    20,   -72,   -72,   -72,   -31,   -72,   -72,   -33,   -72,
     -72,   -72,   -71,   -72,   -72,   -72,   -72,   -72,   -72,   -72,
     -72,     3,   -72,   -72
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     6,     7,     8,    29,    30,    71,    72,    33,    34,
      36,    37,     9,    10,    44,    45,    11,    12,    20,    49,
      13,    14,    24,    15,    16,    22,    39,    55,    73,    57,
      58,    59,    82,    83
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      48,    47,    81,    51,    27,     1,     2,    54,     3,     4,
      28,     5,    86,    31,    61,    17,    18,    28,    64,    32,
      19,    32,    21,    23,    25,    38,    35,    42,    40,    41,
      75,    46,    43,    76,    47,    51,    50,    77,    28,    32,
      52,    56,    60,    26,    80,    84,    63,    66,    67,    68,
      69,    70,    78,    79,    85,     0,    53,     0,    62,    65,
       0,    74
};

static const yytype_int8 yycheck[] =
{
      31,    29,    73,    33,    14,     7,     8,    38,    10,    11,
      20,    13,    83,    14,    17,     8,    20,    20,    17,    20,
      20,    20,    20,    18,     0,    14,    20,    14,    20,    20,
      61,    15,    20,    64,    62,    65,    15,    68,    20,    20,
      15,    12,    19,     7,    71,    78,    20,    20,    20,    17,
      20,    20,    15,    15,    20,    -1,    36,    -1,    44,    49,
      -1,    58
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     7,     8,    10,    11,    13,    22,    23,    24,    33,
      34,    37,    38,    41,    42,    44,    45,     8,    20,    20,
      39,    20,    46,    18,    43,     0,    24,    14,    20,    25,
      26,    14,    20,    29,    30,    20,    31,    32,    14,    47,
      20,    20,    14,    20,    35,    36,    15,    26,    36,    40,
      15,    30,    15,    32,    36,    48,    12,    50,    51,    52,
      19,    17,    25,    20,    17,    29,    20,    20,    17,    20,
      20,    27,    28,    49,    52,    36,    36,    36,    15,    15,
      28,    43,    53,    54,    39,    20,    43
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    21,    22,    22,    23,    23,    24,    24,    24,    24,
      25,    25,    26,    27,    27,    28,    29,    29,    30,    31,
      31,    32,    33,    33,    33,    33,    34,    34,    35,    35,
      36,    37,    37,    37,    37,    38,    39,    40,    40,    41,
      41,    42,    43,    44,    45,    46,    47,    47,    48,    48,
      49,    49,    50,    50,    51,    51,    52,    53,    53,    54,
      54
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     1,     1,
       2,     1,     3,     2,     1,     3,     2,     1,     3,     2,
       1,     3,     4,     3,     2,     1,     3,     2,     3,     1,
       1,     4,     3,     2,     1,     2,     2,     3,     1,     2,
       1,     2,     3,     5,     2,     1,     2,     0,     3,     1,
       1,     0,     1,     0,     2,     1,     4,     1,     0,     2,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (yyscanner, coll, category, human, document, archive, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if CATA_DEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, yyscanner, coll, category, human, document, archive); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, yyscan_t yyscanner, Collection* coll, Category* category, Human* human, Document* document, Archive* archive)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yyscanner);
  YYUSE (coll);
  YYUSE (category);
  YYUSE (human);
  YYUSE (document);
  YYUSE (archive);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, yyscan_t yyscanner, Collection* coll, Category* category, Human* human, Document* document, Archive* archive)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yyscanner, coll, category, human, document, archive);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, yyscan_t yyscanner, Collection* coll, Category* category, Human* human, Document* document, Archive* archive)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , yyscanner, coll, category, human, document, archive);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, yyscanner, coll, category, human, document, archive); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !CATA_DEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !CATA_DEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, yyscan_t yyscanner, Collection* coll, Category* category, Human* human, Document* document, Archive* archive)
{
  YYUSE (yyvaluep);
  YYUSE (yyscanner);
  YYUSE (coll);
  YYUSE (category);
  YYUSE (human);
  YYUSE (document);
  YYUSE (archive);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (yyscan_t yyscanner, Collection* coll, Category* category, Human* human, Document* document, Archive* archive)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 131 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_WARNING, "%s", "the catalog file was empty");
}
#line 1392 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 136 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "stanzas: stanzas stanza");
}
#line 1401 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 141 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "stanzas: stanza");
}
#line 1409 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 147 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "stanza: defCategory");
}
#line 1417 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 151 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "stanza: defHuman");
}
#line 1425 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 155 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "stanza: defDocument");
}
#line 1433 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 159 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "stanza: deFaRCHIVE");
}
#line 1441 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 167 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "cateCaracs: cateCaracs cateCarac");
}
#line 1450 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 172 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
 logParser(LOG_INFO, "line %i: %s", LINENO, "cateCaracs: cateCarac");
}
#line 1458 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 177 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  Carac* carac = 0;
  logParser(LOG_INFO, "line %i: cateCarac: %s = %s", LINENO, (yyvsp[-2].string), (yyvsp[0].string));
  if (!(carac = addCarac(coll, (yyvsp[-2].string)))) YYERROR;
  if (!addAssoCarac(coll, carac, CATE, category, (yyvsp[0].string))) YYERROR;
}
#line 1469 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 185 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "docCaracs: docCaracs docCarac");
}
#line 1478 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 190 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
 logParser(LOG_INFO, "line %i: %s", LINENO, "docCaracs: docCarac");
}
#line 1486 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 195 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  Carac* carac = 0;
  logParser(LOG_INFO, "line %i: docCarac: %s = %s", LINENO, (yyvsp[-2].string), (yyvsp[0].string));
  if (!(carac = addCarac(coll, (yyvsp[-2].string)))) YYERROR;
  if (!addAssoCarac(coll, carac, DOC, document, (yyvsp[0].string))) YYERROR;
}
#line 1497 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 203 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "humCaracs: humCaracs humCarac");
}
#line 1506 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 208 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
 logParser(LOG_INFO, "line %i: %s", LINENO, "humCaracs: humCarac");
}
#line 1514 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 213 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  Carac* carac = 0;
  logParser(LOG_INFO, "line %i: humCarac: %s = %s", LINENO, (yyvsp[-2].string), (yyvsp[0].string));
  if (!(carac = addCarac(coll, (yyvsp[-2].string)))) YYERROR;
  if (!addAssoCarac(coll, carac, HUM, human, (yyvsp[0].string))) YYERROR;
}
#line 1525 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 221 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "archCaracs: archCaracs archCarac");
}
#line 1534 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 226 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
 logParser(LOG_INFO, "line %i: %s", LINENO, "archCaracs: archCarac");
}
#line 1542 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 231 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  Carac* carac = 0;
  logParser(LOG_INFO, "line %i: archCarac: %s = %s", LINENO, (yyvsp[-2].string), (yyvsp[0].string));
  if (!(carac = addCarac(coll, (yyvsp[-2].string)))) YYERROR;
  if (!addAssoCarac(coll, carac, ARCH, archive, (yyvsp[0].string))) YYERROR;
}
#line 1553 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 241 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "newCategory : category caracs");
  category = 0;
}
#line 1563 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 247 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "newCategory : category");
  category = 0;
}
#line 1573 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 253 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "newCategory cateCaracs");
  category = 0;
}
#line 1583 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 259 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "newCategory");
  category = 0;
}
#line 1592 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 266 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "newCategory: TOP CATEGORY category");
  if (!((yyval.category) = addCategory(coll, (yyvsp[0].string), TRUE))) YYERROR;
  category = (yyval.category);
}
#line 1603 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 273 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "newCategory: CATEGORY category");
  if (!((yyval.category) = addCategory(coll, (yyvsp[0].string), FALSE))) YYERROR;
  category = (yyval.category);
}
#line 1614 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 281 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "categories: categories , category");
  if (!addCategoryLink(coll, (yyvsp[0].category), category)) YYERROR;
}
#line 1624 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 287 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "categories: category");
  if (!addCategoryLink(coll, (yyvsp[0].category), category)) YYERROR;
}
#line 1633 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 294 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: category: %s", LINENO, (yyvsp[0].string));
  if (!((yyval.category) = addCategory(coll, (yyvsp[0].string), FALSE))) YYERROR;
}
#line 1642 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 303 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "defHuman: newHuman catCOLON humCategories humCaracs");
  human = 0;
}
#line 1652 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 309 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "defHuman: newHuman : humCategories");
  human = 0;
}
#line 1662 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 315 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "defHuman: newHuman humCaracs");
  human = 0;
}
#line 1672 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 321 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "defHuman: newHuman");
  human = 0;
}
#line 1681 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 328 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "newHuman: catHUMAN human");
  human = (yyvsp[0].human);
}
#line 1691 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 336 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
    logParser(LOG_INFO, "line %i: human: %s %s", LINENO, (yyvsp[-1].string), (yyvsp[0].string));
    if (!((yyval.human) = addHuman(coll, (yyvsp[-1].string), (yyvsp[0].string)))) YYERROR;
}
#line 1700 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 343 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO,
	    "humCategories: humCategories , category");
  if (!addHumanToCategory(coll, human, (yyvsp[0].category))) YYERROR;
}
#line 1710 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 349 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "humCategories: category");
  if (!addHumanToCategory(coll, human, (yyvsp[0].category))) YYERROR;
}
#line 1720 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 359 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "defArchive: newArchive caracs");
  archive = 0;
}
#line 1730 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 365 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "defArchive: neWArchive");
  archive = 0;
}
#line 1740 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 373 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "newArchive: catARCHIVE archive");
  archive = (yyvsp[0].archive);
}
#line 1750 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 381 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: archive: %s:%lli", LINENO, (yyvsp[-2].hash), (yyvsp[0].size));
  if (!((yyval.archive) = addArchive(coll, (yyvsp[-2].hash), (yyvsp[0].size)))) YYERROR;
}
#line 1759 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 390 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "defDocument: newDocument docCategories "
	    "docWiths docCaracs docArchives");
  document = 0;
}
#line 1770 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 399 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "newDocument: catDOCUMENT document");
  document = (yyvsp[0].document);
}
#line 1780 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 407 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: document: %s", LINENO, (yyvsp[0].string));
  if (!((yyval.document) = addDocument(coll, (yyvsp[0].string)))) YYERROR;
}
#line 1789 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 414 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "docCategories2: : docCategories");
}
#line 1798 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 419 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "docCategories: nil");
}
#line 1807 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 426 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "docCategories: docCategories , category");
  if (!addDocumentToCategory(coll, document, (yyvsp[0].category))) YYERROR;
}
#line 1817 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 432 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "docCategories: category");
  if (!addDocumentToCategory(coll, document, (yyvsp[0].category))) YYERROR;
}
#line 1827 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 440 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "docCaracs2: docCaracs");
}
#line 1836 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 445 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, 
	    "docCaracs2: (0)");
}
#line 1845 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 452 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "docWiths: roles");
}
#line 1853 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 456 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "docWiths: (0)");
}
#line 1861 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 461 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "roles: roles role");
}
#line 1869 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 465 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
 logParser(LOG_INFO, "line %i: %s", LINENO, "roles: role");
}
#line 1877 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 470 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  Role* role = 0;
  logParser(LOG_INFO, "line %i: role: WITH %s = human", LINENO, (yyvsp[-2].string));
  if (!(role = addRole(coll, (yyvsp[-2].string)))) YYERROR;
  if (!addAssoRole(coll, role, (yyvsp[0].human), document)) YYERROR;
}
#line 1888 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 478 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: docArchives: archives", LINENO);
}
#line 1896 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 482 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: docArchives: (0)", LINENO);
}
#line 1904 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 487 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO,
	    "archives: archives archive");
  if (!addArchiveToDocument(coll, (yyvsp[0].archive), document)) YYERROR;
}
#line 1914 "catalogFile.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 493 "../parser/catalogFile.y" /* yacc.c:1646  */
    {
  logParser(LOG_INFO, "line %i: %s", LINENO, "archives: archive");
 if (!addArchiveToDocument(coll, (yyvsp[0].archive), document)) YYERROR;
}
#line 1923 "catalogFile.tab.c" /* yacc.c:1646  */
    break;


#line 1927 "catalogFile.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (yyscanner, coll, category, human, document, archive, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yyscanner, coll, category, human, document, archive, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, yyscanner, coll, category, human, document, archive);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yyscanner, coll, category, human, document, archive);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (yyscanner, coll, category, human, document, archive, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, yyscanner, coll, category, human, document, archive);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yyscanner, coll, category, human, document, archive);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 498 "../parser/catalogFile.y" /* yacc.c:1906  */


/* epilogue: =======================================================*/


/*=======================================================================
 * Function   : catalogFile_error
 * Description: Emit an error message. Called by the parser on error
 *              state.
 * Synopsis   : void catalogFile_error(char* message)
 * Input      : char* message = the error message.
 * Output     : N/A
 =======================================================================*/
void cata_error(yyscan_t yyscanner, Collection* coll, Category* category,
		Human* human, Document* document, Archive* archive,
		const char* message)
{
  logEmit(LOG_ERR, "%s on token '%s' line %i\n",
	  message, cata_get_text(yyscanner), LINENO);
}


/*=======================================================================
 * Function   : parseCatalogFile
 * Description: Parse the catalog
 * Synopsis   : int parseCatalogTree(const char* path, int debugFlag)
 * Input      : const char* catalog: the catalog path
 * Output     : TRUE on success
=======================================================================*/
int parseCatalogFile(Collection* coll, const char* path)
{
  int rc = FALSE;
  FILE* inputStream = stdin;
  yyscan_t scanner;
  Category* category = 0;
  Human*    human = 0;
  Document* document = 0;
  Archive*  archive = 0;
  
  checkCollection(coll);
  logParser(LOG_INFO, "parse %s catalog", coll->label);

  // initialise scanner
  if (cata_lex_init(&scanner)) {
    logEmit(LOG_ERR, "%s", "error initializing scanner");
    goto error;
  }

  // scan input file if defined (else stdin)
  inputStream = stdin;
  if (path != 0) {
    if ((inputStream = fopen(path, "r")) == 0) {
      logEmit(LOG_ERR, "cannot open input stream: %s", path); 
      goto error;
    }
    if (!lock(fileno(inputStream), F_RDLCK)) goto error;
    logEmit(LOG_DEBUG, "parse catalog file: %s", path);
  }
  cata_set_in(inputStream, scanner);

  // debug mode for scanner
  cata_set_debug(env.debugLexer, scanner);
  logEmit(LOG_DEBUG, "cata_set_debug = %i", cata_get_debug(scanner));

  // call the parser
  if (cata_parse(scanner, coll, category, human, document, archive)) {
    logEmit(LOG_ERR, "catalog file parser error on line %i",
	    cata_get_lineno(scanner));
    logEmit(LOG_ERR, "please edit %s", path);
    goto error;
  }

  if (inputStream != stdin) {
    if (!unLock(fileno(inputStream))) goto error;
    fclose(inputStream);
  }
  rc = TRUE;
 error:
  cata_lex_destroy(scanner);
  return rc;
}

/************************************************************************/

#ifdef utMAIN
#include "../misc/command.h"
#include "confFile.tab.h"
GLOBAL_STRUCT_DEF;

/*=======================================================================
 * Function   : usage
 * Description: Print the usage.
 * Synopsis   : static void usage(char* programName)
 * Input      : programName = the name of the program; usually argv[0].
 * Output     : N/A
 =======================================================================*/
static void 
usage(char* programName)
{
  parserUsage(programName);
  fprintf(stderr, " [ -i inputPath ]");
  
  parserOptions();
  fprintf(stderr, "  ---\n"
	  "  -i, --input\t\tinput file to parse\n");
  return;
}


/*=======================================================================
 * Function   : main 
 * Author     : Nicolas ROCHE
 * modif      : 2012/05/01
 * Description: unitary test for this parser module
 * Synopsis   : ./utcatalogFile.tab
 * Input      : -i inputPath
 * Output     : Should display the same content
 =======================================================================*/
int 
main(int argc, char** argv)
{
  Configuration* conf = (Configuration*)conf;
  Collection* coll = 0;
  char* inputPath = 0;
  // ---
  int rc = 0;
  int cOption = EOF;
  char* programName = *argv;
  char* options = PARSER_SHORT_OPTIONS"i:";
  struct option longOptions[] = {
     {"input", required_argument, 0, 'i'},
    PARSER_LONG_OPTIONS,
    {0, 0, 0, 0}
  };

  // import mdtx environment
  env.debugParser = TRUE;
  getEnv(&env);

  // parse the command line
  while((cOption = getopt_long(argc, argv, options, longOptions, 0)) 
	!= EOF) {
    switch(cOption) {
      
    case 'i':
      if(isEmptyString(optarg)) {
	fprintf(stderr, 
		"%s: nil or empty argument for the input stream\n",
		programName);
	rc = 2;
      }
      else {
	if ((inputPath = (char*)malloc(sizeof(char) * strlen(optarg) + 1))
	    == 0) {
	  fprintf(stderr, 
		  "%s: cannot allocate memory for the input stream name\n", 
		  programName);
	  rc = 3;
	}
	else {
	  strcpy(inputPath, optarg);
	}
      }
      break;
		
      GET_PARSER_OPTIONS; // generic options
    }
    if (rc) goto optError;
  }

  // export mdtx environment
  if (!setEnv(programName, &env)) goto optError;

  /************************************************************************/
  if (!(conf = getConfiguration())) goto error;
  if (!parseConfiguration(conf->confFile)) goto error;
  if (!(coll = getCollection("coll1"))) goto error;
  if (!expandCollection(coll)) goto error;

  if (!parseCatalogFile(coll, inputPath)) goto error;
  if (!serializeCatalogTree(coll)) goto error;
  /************************************************************************/

  rc = TRUE;
 error:
  freeConfiguration();
  destroyString(inputPath);
  ENDINGS;
  rc=!rc;
 optError:
  exit(rc);
}
 
#endif // utMAIN

/* Local Variables: */
/* mode: c *//* mode: font-lock */
/* mode: auto-fill */
/* End: */
